EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TEXTBOX_EVENT_SELECTION_PASTE =
   EFL_EVENT_DESCRIPTION("selection,paste");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TEXTBOX_EVENT_SELECTION_COPY =
   EFL_EVENT_DESCRIPTION("selection,copy");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TEXTBOX_EVENT_SELECTION_CUT =
   EFL_EVENT_DESCRIPTION("selection,cut");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TEXTBOX_EVENT_CHANGED =
   EFL_EVENT_DESCRIPTION("changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_TEXTBOX_EVENT_CONTEXT_OPEN =
   EFL_EVENT_DESCRIPTION("context,open");

void _efl_ui_textbox_scrollable_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool scroll);


static Eina_Error
__eolian_efl_ui_textbox_scrollable_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_textbox_scrollable_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_textbox_scrollable_set, EFL_FUNC_CALL(scroll), Eina_Bool scroll);

Eina_Bool _efl_ui_textbox_scrollable_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


static Eina_Value
__eolian_efl_ui_textbox_scrollable_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_textbox_scrollable_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_textbox_scrollable_get, Eina_Bool, EINA_FALSE /* false */);

void _efl_ui_textbox_context_menu_enabled_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool enabled);


static Eina_Error
__eolian_efl_ui_textbox_context_menu_enabled_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_textbox_context_menu_enabled_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_textbox_context_menu_enabled_set, EFL_FUNC_CALL(enabled), Eina_Bool enabled);

Eina_Bool _efl_ui_textbox_context_menu_enabled_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


static Eina_Value
__eolian_efl_ui_textbox_context_menu_enabled_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_textbox_context_menu_enabled_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_textbox_context_menu_enabled_get, Eina_Bool, 0);

void _efl_ui_textbox_cnp_dnd_mode_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Ui_Textbox_Cnp_Content allowed_formats);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_textbox_cnp_dnd_mode_set, EFL_FUNC_CALL(allowed_formats), Efl_Ui_Textbox_Cnp_Content allowed_formats);

Efl_Ui_Textbox_Cnp_Content _efl_ui_textbox_cnp_dnd_mode_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_textbox_cnp_dnd_mode_get, Efl_Ui_Textbox_Cnp_Content, 0);

void _efl_ui_textbox_selection_handles_enabled_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool enabled);


static Eina_Error
__eolian_efl_ui_textbox_selection_handles_enabled_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_textbox_selection_handles_enabled_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_textbox_selection_handles_enabled_set, EFL_FUNC_CALL(enabled), Eina_Bool enabled);

Eina_Bool _efl_ui_textbox_selection_handles_enabled_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


static Eina_Value
__eolian_efl_ui_textbox_selection_handles_enabled_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_textbox_selection_handles_enabled_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_textbox_selection_handles_enabled_get, Eina_Bool, 0);

void _efl_ui_textbox_item_factory_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Canvas_Textblock_Factory *item_factory);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_textbox_item_factory_set, EFL_FUNC_CALL(item_factory), Efl_Canvas_Textblock_Factory *item_factory);

Efl_Canvas_Textblock_Factory *_efl_ui_textbox_item_factory_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_textbox_item_factory_get, Efl_Canvas_Textblock_Factory *, NULL);

Efl_Text_Cursor_Object *_efl_ui_textbox_cursor_create(Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_textbox_cursor_create, Efl_Text_Cursor_Object *, NULL);

void _efl_ui_textbox_selection_copy(Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_textbox_selection_copy);

void _efl_ui_textbox_selection_paste(Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_textbox_selection_paste);

void _efl_ui_textbox_selection_cut(Eo *obj, Efl_Ui_Textbox_Data *pd);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_textbox_selection_cut);

Efl_Object *_efl_ui_textbox_efl_object_constructor(Eo *obj, Efl_Ui_Textbox_Data *pd);


Efl_Object *_efl_ui_textbox_efl_object_finalize(Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_object_destructor(Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_gfx_entity_visible_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool v);


void _efl_ui_textbox_efl_gfx_entity_position_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Position2D pos);


void _efl_ui_textbox_efl_gfx_entity_size_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Size2D size);


void _efl_ui_textbox_efl_canvas_group_group_member_add(Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Canvas_Object *sub_obj);


void _efl_ui_textbox_efl_canvas_group_group_calculate(Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Bool _efl_ui_textbox_efl_ui_widget_on_access_activate(Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Ui_Activate act);


Eina_Error _efl_ui_textbox_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Bool _efl_ui_textbox_efl_ui_widget_widget_input_event_handler(Eo *obj, Efl_Ui_Textbox_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


Eina_Bool _efl_ui_textbox_efl_ui_focus_object_on_focus_update(Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Rect _efl_ui_textbox_efl_ui_widget_interest_region_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_widget_disabled_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool disabled);


void _efl_ui_textbox_efl_text_format_password_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool enabled);


void _efl_ui_textbox_efl_text_format_multiline_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool enabled);


void _efl_ui_textbox_efl_text_style_text_color_set(Eo *obj, Efl_Ui_Textbox_Data *pd, unsigned char r, unsigned char g, unsigned char b, unsigned char a);


Efl_Access_State_Set _efl_ui_textbox_efl_access_object_state_set_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


const char *_efl_ui_textbox_efl_access_object_i18n_name_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


char *_efl_ui_textbox_efl_access_text_access_text_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, int start_offset, int end_offset);


void _efl_ui_textbox_efl_access_text_string_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Access_Text_Granularity granularity, int *start_offset, int *end_offset, char **string);


Eina_Bool _efl_ui_textbox_efl_access_text_attribute_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, const char *name, int *start_offset, int *end_offset, char **value);


void _efl_ui_textbox_efl_access_text_text_attributes_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, int *start_offset, int *end_offset, Eina_List **attributes);


Eina_List *_efl_ui_textbox_efl_access_text_default_attributes_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Bool _efl_ui_textbox_efl_access_text_caret_offset_set(Eo *obj, Efl_Ui_Textbox_Data *pd, int offset);


int _efl_ui_textbox_efl_access_text_caret_offset_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Unicode _efl_ui_textbox_efl_access_text_character_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, int offset);


Eina_Bool _efl_ui_textbox_efl_access_text_character_extents_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, int offset, Eina_Bool screen_coords, Eina_Rect *rect);


int _efl_ui_textbox_efl_access_text_character_count_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


int _efl_ui_textbox_efl_access_text_offset_at_point_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool screen_coords, int x, int y);


Eina_List *_efl_ui_textbox_efl_access_text_bounded_ranges_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool screen_coords, Eina_Rect rect, Efl_Access_Text_Clip_Type xclip, Efl_Access_Text_Clip_Type yclip);


Eina_Bool _efl_ui_textbox_efl_access_text_range_extents_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool screen_coords, int start_offset, int end_offset, Eina_Rect *rect);


Eina_Bool _efl_ui_textbox_efl_access_text_access_selection_set(Eo *obj, Efl_Ui_Textbox_Data *pd, int selection_number, int start_offset, int end_offset);


void _efl_ui_textbox_efl_access_text_access_selection_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, int selection_number, int *start_offset, int *end_offset);


int _efl_ui_textbox_efl_access_text_selections_count_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Bool _efl_ui_textbox_efl_access_text_selection_add(Eo *obj, Efl_Ui_Textbox_Data *pd, int start_offset, int end_offset);


Eina_Bool _efl_ui_textbox_efl_access_text_selection_remove(Eo *obj, Efl_Ui_Textbox_Data *pd, int selection_number);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_text_content_set(Eo *obj, Efl_Ui_Textbox_Data *pd, const char *string);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_insert(Eo *obj, Efl_Ui_Textbox_Data *pd, const char *string, int position);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_copy(Eo *obj, Efl_Ui_Textbox_Data *pd, int start, int end);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_cut(Eo *obj, Efl_Ui_Textbox_Data *pd, int start, int end);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_delete(Eo *obj, Efl_Ui_Textbox_Data *pd, int start, int end);


Eina_Bool _efl_ui_textbox_efl_access_editable_text_paste(Eo *obj, Efl_Ui_Textbox_Data *pd, int position);


void _efl_ui_textbox_efl_text_interactive_editable_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool editable);


Efl_Object *_efl_ui_textbox_efl_part_part_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, const char *name);


void _efl_ui_textbox_efl_ui_scrollable_content_pos_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Position2D pos);


Eina_Position2D _efl_ui_textbox_efl_ui_scrollable_content_pos_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Size2D _efl_ui_textbox_efl_ui_scrollable_content_size_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


Eina_Rect _efl_ui_textbox_efl_ui_scrollable_viewport_geometry_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_scrollable_bounce_enabled_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool horiz, Eina_Bool vert);


void _efl_ui_textbox_efl_ui_scrollable_bounce_enabled_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool *horiz, Eina_Bool *vert);


void _efl_ui_textbox_efl_ui_scrollable_scroll_freeze_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool freeze);


Eina_Bool _efl_ui_textbox_efl_ui_scrollable_scroll_freeze_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_scrollable_scroll_hold_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool hold);


Eina_Bool _efl_ui_textbox_efl_ui_scrollable_scroll_hold_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_scrollable_looping_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool loop_h, Eina_Bool loop_v);


void _efl_ui_textbox_efl_ui_scrollable_looping_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool *loop_h, Eina_Bool *loop_v);


void _efl_ui_textbox_efl_ui_scrollable_movement_block_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Efl_Ui_Layout_Orientation block);


Efl_Ui_Layout_Orientation _efl_ui_textbox_efl_ui_scrollable_movement_block_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_scrollable_gravity_set(Eo *obj, Efl_Ui_Textbox_Data *pd, double x, double y);


void _efl_ui_textbox_efl_ui_scrollable_gravity_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, double *x, double *y);

static void __eolian_efl_ui_textbox_efl_ui_scrollable_gravity_get(const Eo *obj, Efl_Ui_Textbox_Data *pd, double *x, double *y)
{
   if (x) *x = 0.000000;
   if (y) *y = 0.000000;
   _efl_ui_textbox_efl_ui_scrollable_gravity_get(obj, pd, x, y);
}


void _efl_ui_textbox_efl_ui_scrollable_match_content_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Bool w, Eina_Bool h);


void _efl_ui_textbox_efl_ui_scrollable_step_size_set(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Position2D step);


Eina_Position2D _efl_ui_textbox_efl_ui_scrollable_step_size_get(const Eo *obj, Efl_Ui_Textbox_Data *pd);


void _efl_ui_textbox_efl_ui_scrollable_scroll(Eo *obj, Efl_Ui_Textbox_Data *pd, Eina_Rect rect, Eina_Bool animation);


static Eina_Bool
_efl_ui_textbox_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_TEXTBOX_EXTRA_OPS
#define EFL_UI_TEXTBOX_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_scrollable_set, _efl_ui_textbox_scrollable_set),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_scrollable_get, _efl_ui_textbox_scrollable_get),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_context_menu_enabled_set, _efl_ui_textbox_context_menu_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_context_menu_enabled_get, _efl_ui_textbox_context_menu_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_cnp_dnd_mode_set, _efl_ui_textbox_cnp_dnd_mode_set),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_cnp_dnd_mode_get, _efl_ui_textbox_cnp_dnd_mode_get),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_selection_handles_enabled_set, _efl_ui_textbox_selection_handles_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_selection_handles_enabled_get, _efl_ui_textbox_selection_handles_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_item_factory_set, _efl_ui_textbox_item_factory_set),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_item_factory_get, _efl_ui_textbox_item_factory_get),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_cursor_create, _efl_ui_textbox_cursor_create),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_selection_copy, _efl_ui_textbox_selection_copy),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_selection_paste, _efl_ui_textbox_selection_paste),
      EFL_OBJECT_OP_FUNC(efl_ui_textbox_selection_cut, _efl_ui_textbox_selection_cut),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_textbox_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_textbox_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_textbox_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_visible_set, _efl_ui_textbox_efl_gfx_entity_visible_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_position_set, _efl_ui_textbox_efl_gfx_entity_position_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_entity_size_set, _efl_ui_textbox_efl_gfx_entity_size_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_member_add, _efl_ui_textbox_efl_canvas_group_group_member_add),
      EFL_OBJECT_OP_FUNC(efl_canvas_group_calculate, _efl_ui_textbox_efl_canvas_group_group_calculate),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_on_access_activate, _efl_ui_textbox_efl_ui_widget_on_access_activate),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_textbox_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _efl_ui_textbox_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_on_focus_update, _efl_ui_textbox_efl_ui_focus_object_on_focus_update),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_interest_region_get, _efl_ui_textbox_efl_ui_widget_interest_region_get),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_disabled_set, _efl_ui_textbox_efl_ui_widget_disabled_set),
      EFL_OBJECT_OP_FUNC(efl_text_password_set, _efl_ui_textbox_efl_text_format_password_set),
      EFL_OBJECT_OP_FUNC(efl_text_multiline_set, _efl_ui_textbox_efl_text_format_multiline_set),
      EFL_OBJECT_OP_FUNC(efl_text_color_set, _efl_ui_textbox_efl_text_style_text_color_set),
      EFL_OBJECT_OP_FUNC(efl_access_object_state_set_get, _efl_ui_textbox_efl_access_object_state_set_get),
      EFL_OBJECT_OP_FUNC(efl_access_object_i18n_name_get, _efl_ui_textbox_efl_access_object_i18n_name_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_get, _efl_ui_textbox_efl_access_text_access_text_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_string_get, _efl_ui_textbox_efl_access_text_string_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_attribute_get, _efl_ui_textbox_efl_access_text_attribute_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_attributes_get, _efl_ui_textbox_efl_access_text_text_attributes_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_default_attributes_get, _efl_ui_textbox_efl_access_text_default_attributes_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_caret_offset_set, _efl_ui_textbox_efl_access_text_caret_offset_set),
      EFL_OBJECT_OP_FUNC(efl_access_text_caret_offset_get, _efl_ui_textbox_efl_access_text_caret_offset_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_character_get, _efl_ui_textbox_efl_access_text_character_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_character_extents_get, _efl_ui_textbox_efl_access_text_character_extents_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_character_count_get, _efl_ui_textbox_efl_access_text_character_count_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_offset_at_point_get, _efl_ui_textbox_efl_access_text_offset_at_point_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_bounded_ranges_get, _efl_ui_textbox_efl_access_text_bounded_ranges_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_range_extents_get, _efl_ui_textbox_efl_access_text_range_extents_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_access_selection_set, _efl_ui_textbox_efl_access_text_access_selection_set),
      EFL_OBJECT_OP_FUNC(efl_access_text_access_selection_get, _efl_ui_textbox_efl_access_text_access_selection_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_selections_count_get, _efl_ui_textbox_efl_access_text_selections_count_get),
      EFL_OBJECT_OP_FUNC(efl_access_text_selection_add, _efl_ui_textbox_efl_access_text_selection_add),
      EFL_OBJECT_OP_FUNC(efl_access_text_selection_remove, _efl_ui_textbox_efl_access_text_selection_remove),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_content_set, _efl_ui_textbox_efl_access_editable_text_text_content_set),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_insert, _efl_ui_textbox_efl_access_editable_text_insert),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_copy, _efl_ui_textbox_efl_access_editable_text_copy),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_cut, _efl_ui_textbox_efl_access_editable_text_cut),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_delete, _efl_ui_textbox_efl_access_editable_text_delete),
      EFL_OBJECT_OP_FUNC(efl_access_editable_text_paste, _efl_ui_textbox_efl_access_editable_text_paste),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_editable_set, _efl_ui_textbox_efl_text_interactive_editable_set),
      EFL_OBJECT_OP_FUNC(efl_part_get, _efl_ui_textbox_efl_part_part_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_pos_set, _efl_ui_textbox_efl_ui_scrollable_content_pos_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_pos_get, _efl_ui_textbox_efl_ui_scrollable_content_pos_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_content_size_get, _efl_ui_textbox_efl_ui_scrollable_content_size_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_viewport_geometry_get, _efl_ui_textbox_efl_ui_scrollable_viewport_geometry_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_bounce_enabled_set, _efl_ui_textbox_efl_ui_scrollable_bounce_enabled_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_bounce_enabled_get, _efl_ui_textbox_efl_ui_scrollable_bounce_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_freeze_set, _efl_ui_textbox_efl_ui_scrollable_scroll_freeze_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_freeze_get, _efl_ui_textbox_efl_ui_scrollable_scroll_freeze_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_hold_set, _efl_ui_textbox_efl_ui_scrollable_scroll_hold_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll_hold_get, _efl_ui_textbox_efl_ui_scrollable_scroll_hold_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_looping_set, _efl_ui_textbox_efl_ui_scrollable_looping_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_looping_get, _efl_ui_textbox_efl_ui_scrollable_looping_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_movement_block_set, _efl_ui_textbox_efl_ui_scrollable_movement_block_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_movement_block_get, _efl_ui_textbox_efl_ui_scrollable_movement_block_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_gravity_set, _efl_ui_textbox_efl_ui_scrollable_gravity_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_gravity_get, __eolian_efl_ui_textbox_efl_ui_scrollable_gravity_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_match_content_set, _efl_ui_textbox_efl_ui_scrollable_match_content_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_step_size_set, _efl_ui_textbox_efl_ui_scrollable_step_size_set),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_step_size_get, _efl_ui_textbox_efl_ui_scrollable_step_size_get),
      EFL_OBJECT_OP_FUNC(efl_ui_scrollable_scroll, _efl_ui_textbox_efl_ui_scrollable_scroll),
      EFL_UI_TEXTBOX_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"scrollable", __eolian_efl_ui_textbox_scrollable_set_reflect, __eolian_efl_ui_textbox_scrollable_get_reflect},
      {"context_menu_enabled", __eolian_efl_ui_textbox_context_menu_enabled_set_reflect, __eolian_efl_ui_textbox_context_menu_enabled_get_reflect},
      {"selection_handles_enabled", __eolian_efl_ui_textbox_selection_handles_enabled_set_reflect, __eolian_efl_ui_textbox_selection_handles_enabled_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_textbox_class_desc = {
   EO_VERSION,
   "Efl.Ui.Textbox",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Textbox_Data),
   _efl_ui_textbox_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_textbox_class_get, &_efl_ui_textbox_class_desc, EFL_UI_LAYOUT_BASE_CLASS, EFL_INPUT_CLICKABLE_MIXIN, EFL_ACCESS_TEXT_INTERFACE, EFL_ACCESS_EDITABLE_TEXT_INTERFACE, EFL_UI_SCROLLABLE_INTERFACE, EFL_TEXT_INTERACTIVE_INTERFACE, EFL_TEXT_MARKUP_INTERFACE, EFL_INPUT_TEXT_ENTITY_INTERFACE, NULL);
